//+------------------------------------------------------------------+
//|                                           Indicator_Painting.mq4 |
//|                                       Copyright  2009, TheXpert |
//|                                           theforexpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TheXpert"
#property link      "theforexpert@gmail.com"

// ====================================================
//     /Experts/Libraries  
// ====================================================
#property library
// ====================================================
//    
// ====================================================
void MarkExtremums(
                   double values[],        //   
                   double& extremums[],    //    
                   int startIndex,         //     ()
                   int endIndex,           //     ()
                   int direction,          // DIR_TOP  DIR_BOTTOM  DIR_ALL    
                   double emptyValueUsed)  //   
  {
//      
   int di=-1;
   if(endIndex>startIndex) di=1;

// 
   for(int i=startIndex;(i>=startIndex && i<=endIndex) || (i>=endIndex && i<=startIndex); i+=di)
     {
      //       
      //    2 ,    ,   
      if(i+2>=Bars)
        {
         continue;
        }

      //    ,   ,    
      if(
         values[i]      == emptyValueUsed ||
         values[i + 1]  == emptyValueUsed ||
         values[i + 2]  == emptyValueUsed ||
         values[i]      == EMPTY_VALUE ||
         values[i + 1]  == EMPTY_VALUE ||
         values[i + 2]  == EMPTY_VALUE
         )
        {
         continue;
        }

      //     
      if(di<0) extremums[i+1]=EMPTY_VALUE;

      //   --  
      if((values[i]-values[i+1])*(values[i+1]-values[i+2])<0 && (values[i]-values[i+1])*direction>=0)
        {
         //     
         extremums[i+1]=values[i+1];
         continue;
        }

      //   --   --     
      //     
      if(values[i+1]==values[i+2] && values[i]!=values[i+1] && (values[i]-values[i+1])*direction>=0)
        {
         //    --   
         //      .

         int index=i+2;
         bool found=false;

         while(index<Bars && values[index]!=emptyValueUsed && values[index]!=EMPTY_VALUE)
           {
            if(values[i+2]!=values[index])
              {
               // ,   
               found=true;
               break;
              }

            index++;
           }

         if(!found)
           {
            //     ,     
            //       
            continue;
           }

         //    
         if((values[i]-values[i+1])*(values[i+1]-values[index])<0)
           {
            //  
            extremums[i+1]=values[i+1];
           }  // else --    ,   
        }
     }
  }
// ====================================================
//  
// ====================================================
void MarkCrosses(
                 double values1[],       //   
                 double values2[],       //   
                 double& crosses[],      //    
                 int startIndex,         //     ()
                 int endIndex,           //     ()
                 int direction,          // CROSS_UP   CROSS_DOWN  CROSS_ALL 
                 double emptyValueUsed)  //   
  {
//      
   int di=-1;
   if(endIndex>startIndex) di=1;

// 
   for(int i=startIndex;(i>=startIndex && i<=endIndex) || (i>=endIndex && i<=startIndex); i+=di)
     {
      //    1  ,    
      if(i+1>=Bars)
        {
         continue;
        }

      //      ,   
      if(
         values1[i]        == emptyValueUsed ||
         values1[i + 1]    == emptyValueUsed ||
         values2[i]        == emptyValueUsed ||
         values2[i + 1]    == emptyValueUsed ||
         values1[i]        == EMPTY_VALUE    ||
         values1[i + 1]    == EMPTY_VALUE    ||
         values2[i]        == EMPTY_VALUE    ||
         values2[i + 1]    == EMPTY_VALUE
         )
        {
         continue;
        }

      //   
      if(di<0) crosses[i]=EMPTY_VALUE;

      //    ( )
      if((values1[i]-values2[i])*(values1[i+1]-values2[i+1])<0 && (values1[i]-values2[i])*direction>=0)
        {
         crosses[i]=values2[i];
         continue;
        }

      //   --   --     
      //     
      if(values1[i+1]==values2[i+1] && values1[i]!=values2[i] && (values1[i]-values2[i])*direction>=0)
        {
         //    --   
         //      .

         int index=i+1;
         bool found=false;
         while(
               index<Bars && 
               values1[index] != emptyValueUsed &&
               values1[index] != EMPTY_VALUE &&
               values2[index] != emptyValueUsed &&
               values2[index] != EMPTY_VALUE)
           {
            if(values1[index]!=values2[index])
              {
               // ,   
               found=true;
               break;
              }

            index++;
           }

         if(!found)
           {
            //     ,     
            //       
            continue;
           }

         //    
         if((values1[i]-values2[i])*(values1[index]-values2[index])<0)
           {
            //  
            crosses[i]=values2[i];
           }  // else    --  
        }
     }
  }
// ====================================================
//   c 
// ====================================================
void MarkLevelCrosses(
                      double values[],        //   
                      double level,           //     
                      double& crosses[],      //    
                      int startIndex,         //     ()
                      int endIndex,           //     ()
                      int direction,          // CROSS_UP   DROSS_DOWN  CROSS_ALL 
                      double emptyValueUsed)  //   
  {
//      
   int di=-1;
   if(endIndex>startIndex) di=1;

// 
   for(int i=startIndex;(i>=startIndex && i<=endIndex) || (i>=endIndex && i<=startIndex); i+=di)
     {
      //    1  ,    
      if(i+1>=Bars)
        {
         continue;
        }

      //      ,   
      if(
         values[i]        == emptyValueUsed ||
         values[i + 1]    == emptyValueUsed ||
         values[i]        == EMPTY_VALUE    ||
         values[i + 1]    == EMPTY_VALUE
         )
        {
         continue;
        }

      //   
      if(di<0) crosses[i]=EMPTY_VALUE;

      //    ( )
      if((values[i]-level)*(values[i+1]-level)<0 && (values[i]-level)*direction>=0)
        {
         crosses[i]=level;
         continue;
        }

      //   --   --     
      //     
      if(values[i+1]==level && values[i]!=level && (values[i]-level)*direction>=0)
        {
         //    --   
         //      .

         int index=i+1;
         bool found=false;
         while(
               index<Bars && 
               values[index] != emptyValueUsed &&
               values[index] != EMPTY_VALUE)
           {
            if(values[index]!=level)
              {
               // ,   
               found=true;
               break;
              }

            index++;
           }

         if(!found)
           {
            //     ,     
            //       
            continue;
           }

         //    
         if((values[i]-level)*(values[index]-level)<0)
           {
            //  
            crosses[i]=level;
           }  // else    --  
        }
     }
  }
// ====================================================
//  
// ====================================================
void MarkLevel(
               double values[],        //   
               double& level[],        //    
               int startIndex,         //     ()
               int endIndex,           //     ()
               double levelValue,      //  
               int condition,          //  (LESS_THAN = -1)    (GREATER_THAN = 1)
               double emptyValueUsed)  //   
  {
   int Depth=2;

//      1 ,   1  
   if(endIndex>startIndex)
     {
      endIndex=MathMax(endIndex,Depth);
     }
   else
     {
      startIndex=MathMax(startIndex,Depth);
     }

//      
   int di=-1;
   if(endIndex>startIndex) di=1;

// 
   for(int i=startIndex;(i>=startIndex && i<=endIndex) || (i>=endIndex && i<=startIndex); i+=di)
     {
      if(values[i]==EMPTY_VALUE || values[i]==emptyValueUsed)
        {
         continue;
        }

      if(di<0) level[i]=EMPTY_VALUE;

      //  
      if((values[i]-levelValue)*condition>=0)
        {
         level[i]=values[i];

         //     
         if((values[i+1]-levelValue)*condition<0 && values[i+1]!=emptyValueUsed && values[i+1]!=EMPTY_VALUE)
           {
            //    ,   
            level[i+1]=levelValue;
           }
        }
      //     
      else
        {
         //    
         if((values[i+1]-levelValue)*condition>=0 && values[i+1]!=EMPTY_VALUE && values[i+1]!=emptyValueUsed)
           {
            //    ,   
            level[i]=levelValue;
           }
        }
     }
  }
// ====================================================
//   
// ====================================================
void MarkDynamicLevel(
                      double values[],        //   
                      double dynamicLevel[],  //     
                      double& level[],        //    
                      int startIndex,         //     ()
                      int endIndex,           //     ()
                      int condition,          //  (LESS_THAN = -1)    (GREATER_THAN = 1)
                      double emptyValueUsed)  //   
  {
   int Depth=2;

//      1 ,   1  
   if(endIndex>startIndex)
     {
      endIndex=MathMax(endIndex,Depth);
     }
   else
     {
      startIndex=MathMax(startIndex,Depth);
     }

//      
   int di=-1;
   if(endIndex>startIndex) di=1;

// 
   for(int i=startIndex;(i>=startIndex && i<=endIndex) || (i>=endIndex && i<=startIndex); i+=di)
     {
      if(values[i]==EMPTY_VALUE || values[i]==emptyValueUsed)
        {
         continue;
        }

      if(di<0) level[i]=EMPTY_VALUE;

      //  
      if((values[i]-dynamicLevel[i])*condition>=0)
        {
         level[i]=values[i];

         //     
         if((values[i+1]-dynamicLevel[i+1])*condition<0 && values[i+1]!=emptyValueUsed && values[i+1]!=EMPTY_VALUE)
           {
            //    ,   
            level[i+1]=dynamicLevel[i+1];
           }
        }
      //     
      else
        {
         //    
         if((values[i+1]-dynamicLevel[i+1])*condition>=0 && values[i+1]!=EMPTY_VALUE && values[i+1]!=emptyValueUsed)
           {
            //    ,   
            level[i]=dynamicLevel[i];
           }
        }
     }
  }
// ====================================================
//   ()
// ====================================================
void MarkGrowing(
                 double values[],        //   
                 double& growing1[],     // 1-    
                 double& growing2[],     // 2-    
                 int startIndex,         //     ()
                 int endIndex,           //     ()
                 double emptyValueUsed)  //   
  {
//      
   int di=-1;
   if(endIndex>startIndex) di=1;
   if(endIndex>=ArraySize(values)) endIndex-=3;
//   
   for(int i=startIndex;(i>=startIndex && i<=endIndex) || (i>=endIndex && i<=startIndex); i+=di)
     {
      //       
      //    2 ,    ,   
      if(i+1>=Bars)
        {
         continue;
        }

      //    ,   ,    
      if(
         values[i]      == emptyValueUsed ||
         values[i + 1]  == emptyValueUsed ||
         values[i]      == EMPTY_VALUE    ||
         values[i + 1]  == EMPTY_VALUE
         )
        {
         continue;
        }

      //   
      if(di < 0) growing1[i] = EMPTY_VALUE;
      if(di < 0) growing2[i] = EMPTY_VALUE;

      //  
      if((i>=0&&i<ArraySize(values)-3)&&values[i]>values[i+1])
        {
         //     
         if(values[i+1]>values[i+2])
           {
            //     
            if(growing1[i+1]!=EMPTY_VALUE) growing1[i]=values[i];
            else                                growing2[i]=values[i];
           }
         //      
         else
           {
            //        2 
            // (1    )
            if(growing2[i+2]==EMPTY_VALUE)
              {
               growing2[i]=values[i];
               growing2[i+1]=values[i+1];
              }
            else
              {
               growing1[i]=values[i];
               growing1[i+1]=values[i+1];
              }
           }
        }
      //      
      else if(i==0)
        {
         if(growing1[i+1]!=EMPTY_VALUE && growing1[i+2]==EMPTY_VALUE)
           {
            growing1[i+1]=EMPTY_VALUE;
           }

         if(growing2[i+1]!=EMPTY_VALUE && growing2[i+2]==EMPTY_VALUE)
           {
            growing2[i+1]=EMPTY_VALUE;
           }
        }
     }
  }
// ====================================================
//   ()
// ====================================================
void MarkReducing(
                  double values[],        //   
                  double& reducing1[],    // 1-    
                  double& reducing2[],    // 2-    
                  int startIndex,         //     ()
                  int endIndex,           //     ()
                  double emptyValueUsed)  //   
  {
//      
   int di=-1;
   if(endIndex>startIndex) di=1;

//   
   for(int i=startIndex;(i>=startIndex && i<=endIndex) || (i>=endIndex && i<=startIndex); i+=di)
     {
      //       
      //    2 ,    ,   
      if(i+1>=Bars)
        {
         continue;
        }

      //    ,   ,    
      if(
         values[i]      == emptyValueUsed ||
         values[i + 1]  == emptyValueUsed ||
         values[i]      == EMPTY_VALUE    ||
         values[i + 1]  == EMPTY_VALUE
         )
        {
         continue;
        }

      //   
      if(di < 0) reducing1[i] = EMPTY_VALUE;
      if(di < 0) reducing2[i] = EMPTY_VALUE;

      //  
      if(values[i]<values[i+1])
        {
         //     
         if(values[i+1]<values[i+2])
           {
            //     
            if(reducing1[i+1]!=EMPTY_VALUE) reducing1[i]=values[i];
            else                                reducing2[i]=values[i];
           }
         //      
         else
           {
            //        2 
            // (1    )
            if(reducing2[i+2]==EMPTY_VALUE)
              {
               reducing2[i]=values[i];
               reducing2[i+1]=values[i+1];
              }
            else
              {
               reducing1[i]=values[i];
               reducing1[i+1]=values[i+1];
              }
           }
        }
      //      
      else if(i==0)
        {
         if(reducing1[i+1]!=EMPTY_VALUE && reducing1[i+2]==EMPTY_VALUE)
           {
            reducing1[i+1]=EMPTY_VALUE;
           }

         if(reducing2[i+1]!=EMPTY_VALUE && reducing2[i+2]==EMPTY_VALUE)
           {
            reducing2[i+1]=EMPTY_VALUE;
           }
        }
     }
  }
//+------------------------------------------------------------------+
