//+------------------------------------------------------------------+
//|                                           Indicator_Painting.mq4 |
//|                                       Copyright  2009, TheXpert |
//|                                           theforexpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TheXpert"
#property link      "theforexpert@gmail.com"

// ====================================================
//     /Experts/Include  
//   Indicator_Painting
// ,    /Experts/Libraries   Indicator_Painting.ex4  Indicator_Painting.mq4
// ====================================================


#import "Indicator_Painting.ex4"

// ,  ,   ,      
//    ,    

//         ,   , ..   

// ====================================================
//    
// ====================================================
void MarkExtremums( 
      double values[],        //   
      double& extremums[],    //    
      int startIndex,         //     ()
      int endIndex,           //     ()
      int direction,          // DIR_TOP  DIR_BOTTOM  DIR_ALL    
      double emptyValueUsed); //   
      
      
// ====================================================
//  
// ====================================================
void MarkCrosses( 
      double values1[],       //   
      double values2[],       //   
      double& crosses[],      //    
      int startIndex,         //     ()
      int endIndex,           //     ()
      int direction,          // CROSS_UP   CROSS_DOWN  CROSS_ALL 
      double emptyValueUsed); //   
      
      
// ====================================================
//   c 
// ====================================================
void MarkLevelCrosses( 
      double values[],        //   
      double level,           //     
      double& crosses[],      //    
      int startIndex,         //     ()
      int endIndex,           //     ()
      int direction,          // CROSS_UP   CROSS_DOWN  CROSS_ALL 
      double emptyValueUsed); //   
      
      
// ====================================================
//  
// ====================================================
void MarkLevel( 
      double values[],        //   
      double& level[],        //    
      int startIndex,         //     ()
      int endIndex,           //     ()
      double levelValue,      //  
      int condition,          //  (LESS_THAN = -1)    (GREATER_THAN = 1)
      double emptyValueUsed); //   
      
// ====================================================
//   
// ====================================================
void MarkDynamicLevel( 
      double values[],        //   
      double dynamicLevel[],  //     
      double& level[],        //    
      int startIndex,         //     ()
      int endIndex,           //     ()
      int condition,          //  (LESS_THAN = -1)    (GREATER_THAN = 1)
      double emptyValueUsed); //   
      
// ====================================================
//   ()
// ====================================================
void MarkGrowing( 
      double values[],        //   
      double& growing1[],     // 1-    
      double& growing2[],     // 2-    
      int startIndex,         //     ()
      int endIndex,           //     ()
      double emptyValueUsed); //   
      
// ====================================================
//   ()
// ====================================================
void MarkReducing( 
      double values[],        //   
      double& reducing1[],     // 1-    
      double& reducing2[],     // 2-    
      int startIndex,         //     ()
      int endIndex,           //     ()
      double emptyValueUsed); //   

#import

#define DIR_TOP -1
#define DIR_BOTTOM 1
#define DIR_ALL 0

#define CROSS_UP 1
#define CROSS_DOWN -1
#define CROSS_ALL 0

#define LESS_THAN -1
#define GREATER_THAN 1